
require "./AI/Const.lua"

-------------------------------------------------
-- Xg\̑NX̒`(List utility)
-------------------------------------------------
-------------------------------------------------
List = {}

function List.new ()					--VXgԂ
	return { first = 0, last = -1}
end

function List.pushleft (list, value)	--list̍ɗvfǉ
	local first = list.first-1
	list.first  = first
	list[first] = value;
end

function List.pushright (list, value)	--list̉Eɗvfǉ
	local last = list.last + 1
	list.last = last
	list[last] = value
end

function List.popleft (list)			--lisẗԍ̒lo
	local first = list.first
	if first > list.last then 
		return nil
	end
	local value = list[first]
	list[first] = nil	-- to allow garbage collection
	list.first = first+1
	return value
end

function List.popright (list)			--lisẗԉE̒lo
	local last = list.last
	if list.first > last then
		return nil
	end
	local value = list[last]
	list[last] = nil
	list.last = last-1
	return value 
end

function List.clear (list)				--listɂ
	for i,v in ipairs(list) do
		list[i] = nil
	end
--[[
	if List.size(list) == 0 then
		return
	end
	local first = list.first
	local last  = list.last
	for i=first, last do
		list[i] = nil
	end
--]]
	list.first = 0
	list.last = -1
end

function List.size (list)				--listɓĂvf̌Ԃ
	local size = list.last - list.first + 1
	return size
end

-------------------------------------------------



-------------------------------------------------
-- W([x1],[y1])ƍW([x2],[y2])̋Ԃ
-------------------------------------------------
-------------------------------------------------
function	GetDistance (x1,y1,x2,y2)
	return math.floor(math.sqrt((x1-x2)^2+(y1-y2)^2))
end
-------------------------------------------------



-------------------------------------------------
-- [id1][id2]̃IuWFNg̋Ԃ
-------------------------------------------------
-------------------------------------------------
function	GetDistance2 (id1, id2)
	local x1, y1 = GetV (V_POSITION,id1)
	local x2, y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance (x1,y1,x2,y2)
end
-------------------------------------------------



-------------------------------------------------
-- [id]̃z̃P~̍WԂ
-------------------------------------------------
-------------------------------------------------
function	GetOwnerPosition (id)
	return GetV (V_POSITION,GetV(V_OWNER,id))
end
-------------------------------------------------



-------------------------------------------------
-- [id]̃zƂ̃P~̋Ԃ
-------------------------------------------------
-------------------------------------------------
function	GetDistanceFromOwner (id)
	local x1, y1 = GetOwnerPosition (id)
	local x2, y2 = GetV (V_POSITION,id)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance (x1,y1,x2,y2)
end
-------------------------------------------------



-------------------------------------------------
-- [id1][id2]̃IuWFNgm
-- 鋗ȂtrueAȂȂfalseԂ
-------------------------------------------------
-------------------------------------------------
function	IsOutOfSight (id1,id2)
	local x1,y1 = GetV (V_POSITION,id1)
	local x2,y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return true
	end
	local d = GetDistance (x1,y1,x2,y2)
	if d > 20 then
		return true
	else
		return false
	end
end
-------------------------------------------------



-------------------------------------------------
-- [id]P~
-- 鋗ȂtrueAȂȂfalseԂ
-------------------------------------------------
-------------------------------------------------
function	IsOutOfOwnerSight(id)
	local x1,y1 = GetV (V_POSITION,id)
	local x2,y2 = GetV (V_POSITION,GetV(V_OWNER,MyID))
	if (x1 == -1 or x2 == -1) then
		return true
	end
	local d = GetDistance (x1,y1,x2,y2)
	if d > 20 then
		return true
	else
		return false
	end
end
-------------------------------------------------



-------------------------------------------------
-- [id1]̍Ugp͈͂[id2]trueA
-- łȂfalseԂB
-------------------------------------------------
-------------------------------------------------
function	IsInAttackSight (id1,id2)
	local x1,y1 = GetV (V_POSITION,id1)
	local x2,y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return false
	end
	local d		= GetDistance (x1,y1,x2,y2)
	local a     = 0
	if (MySkill == 0) then
		a     = ATK_RANGE
	else
		a     = SKL_RANGE
	end

	if a >= d then
		return true;
	else
		return false;
	end
end
-------------------------------------------------

